<?php

namespace App\Admin\Controllers\Episode;

use App\Models\EpisodesCategory;
use Dcat\Admin\Form;
use Dcat\Admin\Grid;
use Dcat\Admin\Show;
use Dcat\Admin\Http\Controllers\AdminController;
use Dingo\Api\Http\Request;

class EpisodesCategoryController extends AdminController
{
    /**
     * Make a grid builder.
     *
     * @return Grid
     */
    protected function grid()
    {
        return Grid::make(new EpisodesCategory(), function (Grid $grid) {
            $grid->model()->orderByDesc('sort');
            $grid->column('id')->sortable();
            $grid->column('name');
            $grid->column('level')->using(config('global.cat_level'));
//            $grid->column('pid','父分类')->display(function () {
//                /* @var EpisodesCategory $this*/
//                return $this->parent ?$this->parent->name : '';
//            });
            $grid->column('sort')->editable();
            //$grid->column('created_at');

            $grid->disableRowSelector();
            $grid->disableViewButton();
        });
    }

    /**
     * Make a form builder.
     *
     * @return Form
     */
    protected function form()
    {
        return Form::make(new EpisodesCategory(), function (Form $form) {

            $form->display('id');
            $form->radio('level')
                ->when(2, function (Form $form){
                    $options = EpisodesCategory::select(['id','name'])
                        ->where('pid',0)
                        ->get()
                        ->pluck('name', 'id');
                    $form->select('pid')->options($options);
                })
                ->options(config('global.cat_level'))
                ->default(1);

            $form->text('name')->required();
            $form->number('sort');

            $form->disableViewButton();
            $form->disableDeleteButton();
            $form->disableListButton();
            $form->disableEditingCheck();
            $form->disableViewCheck();
            $form->disableCreatingCheck();
        });
    }
}
